| Build | Support Server |
|-------|---------|
| [![CI](https://github.com/tachiyomiorg/extensions/workflows/CI/badge.svg?event=push)](https://github.com/tachiyomiorg/extensions/actions/workflows/build_push.yml) | [![Discord](https://img.shields.io/discord/349436576037732353.svg?label=discord&labelColor=7289da&color=2c2f33&style=flat)](https://discord.gg/tachiyomi) |

# ![app icon](./.github/readme-images/app-icon.png)Tachiyomi Extensions
Tachiyomi is a free and open source manga reader for Android 6.0 and above.

This repository contains the available extension catalogues for the [Tachiyomi](https://github.com/tachiyomiorg/tachiyomi) app.

# Usage

Extension sources can be downloaded, installed, and uninstalled via the main Tachiyomi app. They are installed and uninstalled like regular apps, in `.apk` format.

## Downloads

If you prefer to directly download the APK files, they are available via https://tachiyomi.org/extensions/ or directly in this GitHub repository in the [`repo` branch](https://github.com/tachiyomiorg/extensions/tree/repo/apk).

# Requests

To request a new source or bug fix, [create an issue](https://github.com/tachiyomiorg/extensions/issues/new/choose).

Note that requesting something does not imply that something will be added or fixed in a timely fashion or at all since the work is volunteer-based. Furthermore, some sources may be impossible to do or prohibitively difficult to maintain.

If you would like to see a request fulfilled and have the necessary skills to do so, consider contributing! Issues are up-for-grabs for any developer if there is no assigned user already.

# Contributing

Contributions are welcome!

Check out the repo's [issue backlog](https://github.com/tachiyomiorg/extensions/issues) for source requests and bug reports.

To get started with development, see [CONTRIBUTING.md](./CONTRIBUTING.md).

It might also be good to read our [CODE_OF_CONDUCT.md](./CODE_OF_CONDUCT.md).

## License

    Copyright 2015 Javier Tomás

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## Disclaimer

The developer of this application does not have any affiliation with the content providers available.
